const $ = require('jquery');
require("../css/creatCheckTask.less");
require('./modal.js');
const {api,ywCheckApi} = require('./api.js')
const {post,getCookie,getUrlArgObjectNew,emptyBox,downloadExportedData,expJson,initScroll,listenScroll,exportTimeLimit} = require('./utils.js')
require('./../resource/jquery-ui/jquery-ui.min.js');
require('./../resource/jquery-ui/jquery-ui.min.css');
const iconCheck= require("./../images/icon_check.png")
const iconUnCheck = require("./../images/icon_unchecked.png")
const  iconCalenBlue= require("./../images/icon_calen_blue.png")
const  iconCalenGrey= require("./../images/icon_calen_grey.png")
const iconDown= require("./../images/arrow_down.png")
const iconUp = require("./../images/arrow_up.png")
const loadingImg = require("./../images/loading.gif")
const arrowLeft= require("./../images/arrow_left.png")
const arrowRight = require("./../images/arrow_right.png")

listenScroll()
let tabList = [],  global_level="",global_status="0", global_deptId="",
  data_desc=["leaveHospitalDate"],data_asc=[];
let global_activeTabCode = '1';    //激活的tab  code
let isPlacefile = getCookie('isPlacefile')||1

//判断有无某一权限
  function hasData(data){
    let trdObj = JSON.parse(getCookie("trdObj"))
    let lis = trdObj['YH-ZKHC-SCRW']
    if(!lis){
      return false
    }
    if(lis.indexOf(data)>-1){//有权限
        return true
    }
    return false;
}
function getTabData(activePage){
    const filterData = getFilterData();
    const param = {
        jobType:global_activeTabCode,     //科室/质控科/院级
        creatStatus:global_status,
        current:activePage,
        hospitalId:'',
        level:global_level,//病历等级
        department: global_deptId.trim(),
        asc:data_asc,     //升序
        desc:data_desc,       //降序
        size: 15,
        ...filterData
    }
    $('.pagination').html("")
    $('.tbody').html(emptyBox('努力加载中...','',15))
    return post(ywCheckApi.getTaskList,param).then(res =>{
        if(res.data.code == '0'){
            const data = res.data.data;
            tabList = data.records;
            const totalPage = data.pages;
            const totalNum = data.total;
            renderTab(tabList,data.hospitalId);
            renderPagination(totalPage,Number(activePage),totalNum)
            if(totalPage > 1){
                renderPagination(totalPage,Number(activePage),totalNum)
            } else{
                $('.pagination').html("")
            }
        }else{
            $.alerModal({"message":res.data.msg,type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        }
    }).catch((e) =>{
    
    })
}

getTabData(1)

function renderTab(data,hisId){
    let str = ``,code="";
    let hasSelectAll = true;
    if(data.length===0){
      $('.tbody').html(emptyBox(null,15))
    //   initScroll("qcList","YX",1)
      return;
    }
    const titles = $(".tabTitle th[valCode]");
    for(let i = 0; i < data.length; i++){
        const item = data[i]

        str += `
            <tr  data-index=${i}>
                <td class="operaItem taskCheck textCenter" code="${item.behospitalCode}"><img src="${iconUnCheck}" alt=""></td>`;
        for(let i=0;i<titles.length;i++){
            code=$(titles[i]).attr('valCode');
            str +=  `<td class="textCenter"><span data-index=${i}>${ item[code] || "-"}<span></td>`
        }
        str += `<td class="operaItem textCenter ${item.creatStatus=='0'?'taskCancel':'disable'}" code="${item.behospitalCode}">取消</td></tr>`
    }

    if(data.length === 0){
        hasSelectAll = false
    }
    if(hasSelectAll){
        $('.scoreOpera img').attr("src" ,iconCheck)
        $('.scoreOpera').attr("data-selectall",true)
    }else{
        $('.scoreOpera img').attr("src" ,iconUnCheck)
        $('.scoreOpera').attr("data-selectall",false)
    }
    $('.tbody').html(str)
}

//列表获取筛选值
function getFilterData(){
    const obj = {};
    $(".filterBox input[code]").map((i,it)=>{
        obj[$(it).attr("code")]=$(it).val()
    })
    return obj;
}

bindStatusSelect()
//病历等级选择
function bindStatusSelect(){
    $('.statusItem').on("click",function(){
        const statusItemName = $(this).attr("data-name")
        global_status = $(this).attr("data-id")
        $('.selectStatus i').html(statusItemName)
        $(".statusList").css("display", "none")
        $('.selectStatus').removeClass('unSelect')
    })
}

bindLeveldSelect()
//病历等级选择
function bindLeveldSelect(){
    $('.levelItem').on("click",function(){
        const levelItemName = $(this).attr("data-name")
        const levelItemItemId = $(this).attr("data-id")
        global_level =levelItemItemId
        $('.selectLevel i').html(levelItemName)
        $(".levelList").css("display", "none")
        //$(".selectLevel").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
    })
}
//科室列表
function getDeptList(val){
    post(api.getDeptList,{inputStr:val=="全部"?"":val||""}).then(res =>{
        if(res.data.code == '0'){
           const  deptList = res.data.data||[]
           rendeDeptList(deptList)
        }else{rendeDeptList([])}
    }).catch((e) =>{

    })
}
function rendeDeptList(deptList){
    if(deptList.length == 0){
      $('.deptList').html("")
      return
    }
    let str = `<li class="deptItem ellipsis" data-id=" " data-name="全部">全部</li>`;
    for(let i = 0; i < deptList.length; i++){
        str += `<li class="deptItem ellipsis" title=${deptList[i].deptName} data-id=${deptList[i].deptId} data-name=${deptList[i].deptName}> ${deptList[i].deptName}</li>`
    }
    $('.deptList').html(str)
    bindDeptSelect()
}
//科室选择
function bindDeptSelect(){
    $('.deptItem').on("mousedown",function(){
        const deptItemName = $(this).attr("data-name")
        global_deptId = $(this).attr("data-id")
        $('.selectDept i').text(deptItemName)
        $('.selectDept').attr('title',deptItemName)
        $(".deptList").css("display", "none")
        $('.selectDept').removeClass('unSelect')
    })
}
function loading(){
    const str = `
    <div class="loadingBox">
            <div class="mask"></div>
            <img class="loadingImg" src=${loadingImg}  alt="loading" />
        </div>
    `
    $("#mainBox", parent.document).append(str)
}
function hideLoading(){
    $("#mainBox .loadingBox", parent.document).remove()
}
function clearFilter(){
    const days = new Date().getDate()-1;
    let startDate = "-"+days+"d",endDate=new Date();
    $(".filterBox input").val("");
    data_desc=["leaveHospitalDate"];
    //默认日期为本月
    $( "#datepicker" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy-mm-dd",
    }).datepicker( "setDate", startDate);
    $( "#datepicker2" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy-mm-dd"
    }).datepicker( "setDate",endDate);
    $('.selectDept i').text('全部')
    $(".deptList").css("display", "none")
    global_deptId='';
    $('.selectLevel i').html('全部')
    $(".levelList").css("display", "none")
    global_level="";
    $('.selectStatus i').html('未生成')
    $(".statusList").css("display", "none")
    global_status='0'
    $("th[code]").removeClass("asc desc")
}
$(function() {
    $('.datapickerBox').append(`<img class="iconCalen" src=${iconCalenGrey} />`)
    $('.iconCalen').on("mouseenter", function(e){
        $(this).attr("src", iconCalenBlue)
    })
    $('.iconCalen').on("mouseleave", function(e){
        $(this).attr("src", iconCalenGrey)
    })
    $('.iconCalen').on("click", function(e){
        $(this).parent().find("input").focus()
    })

    $(".menu .page", parent.document).removeClass("active")
    $(parent.document).find(".menu .page[code=YH-ZKHC-SCRW]").addClass("active")

    $(".filter").on("click", function(e){
        getTabData(1)
    })
    $(".abnormalClear").on("click", function(e){
        clearFilter();
        getTabData(1)
    })
    //切换tab
    $(".tabBox .tabs button").on("click",(e)=>{
       const me = e.target;
        global_activeTabCode = $(me).attr("data-code");
       $(".tabBox .tabs button").removeClass("active");
       $(me).addClass("active");
       //更新列表并重置筛选条件
       $(".abnormalClear").click();
    });
//选择生成状态
    $('.selectStatus').on("click", function(e){
        e.stopPropagation()
        $(".statusList ").css("display", "none")
        $(".selectStatus .arrow").attr("src",iconDown)
        const showList =  $(".statusList ").css("display")
        if(showList == "none" ||!showList){
            $(".statusList ").css("display","block")
            $(".selectStatus .arrow").attr("src",iconUp)
        }else{
            $(".statusList ").css("display", "none")
            $(".selectStatus .arrow").attr("src",iconDown)
        }
    })
//选择病历等级
    $('.selectLevel').on("click", function(e){
        e.stopPropagation()
        $(".deptList ").css("display", "none")
        $(".selectDept .arrow").attr("src",iconDown)
        const showList =  $(".levelList ").css("display")
        if(showList == "none" ||!showList){
            $(".levelList ").css("display","block")
            $(".selectLevel .arrow").attr("src",iconUp)
        }else{
            $(".levelList ").css("display", "none")
            $(".selectLevel .arrow").attr("src",iconDown)
        }
    })
    //科室选择
    $('.selectDept').on("click", function(e){
        e.stopPropagation();
        $(".levelList ").css("display","none")
        $(".selectLevel .arrow").attr("src",iconDown)
        $(".deptList ").css("display","block")
    })
//获取科室列表
    getDeptList()
    //出院日期初始化
$.datepicker.regional['zh-CN'] = {
    clearText: '清除',
    clearStatus: '清除已选日期',
    closeText: '关闭',
    closeStatus: '不改变当前选择',
    prevText: '<上月',
    prevStatus: '显示上月',
    prevBigText: '<<',
    prevBigStatus: '显示上一年',
    nextText: '下月>',
    nextStatus: '显示下月',
    nextBigText: '>>',
    nextBigStatus: '显示下一年',
    currentText: '今天',
    currentStatus: '显示本月',
    monthNames: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    monthNamesShort: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    yearNamesShort: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    monthStatus: '选择月份',
    yearStatus: '选择年份',
    weekHeader: '周',
    weekStatus: '年内周次',
    dayNames: ['星期日','星期一','星期二','星期三','星期四','星期五','星期六'],
    dayNamesShort: ['周日','周一','周二','周三','周四','周五','周六'],
    dayNamesMin: ['日','一','二','三','四','五','六'],
    dayStatus: '设置 DD 为一周起始',
    dateStatus: '选择 m月 d日, DD',
    dateFormat: 'yy-mm-dd',
    firstDay: 1,
    initStatus: '请选择日期',
    isRTL: false};
    const days = new Date().getDate()-1;
    let startDate = "-"+days+"d",endDate=new Date();
    $.datepicker.setDefaults($.datepicker.regional['zh-CN']);
    $( "#datepicker" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy-mm-dd",
    }).datepicker( "setDate", startDate);
    $( "#datepicker2" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy-mm-dd"
    }).datepicker( "setDate",endDate);
   
});

//分页渲染
function renderPagination(totalPage,activePage,totalNum){
    let str = `<span class="totalSum">共${totalPage}页/${totalNum}条数据</span><span class="prePage"><img class="arrowPage" src=${arrowLeft} /></span>`
    if(totalPage <= 6){
        for(let i = 1; i <= totalPage; i++){
          
            str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
        }
    }else{
        if(activePage <= 3){ //选中页数小于4
            for(let i = 1; i <= 4; i++){
                str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
            }
            str += `<span class="more" >...</span>`
        str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`

        } else if(activePage > totalPage -3){
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(totalPage-3)}" data-page=${totalPage -3}>${totalPage -3}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-2)}" data-page=${totalPage -2}>${totalPage -2}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-1)}" data-page=${totalPage -1}>${totalPage -1}</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        } else {
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(activePage -1)}" data-page=${activePage -1}>${activePage -1}</span>`
            str += `<span class="pageNum ${'page'+activePage}" data-page=${activePage}>${activePage}</span>`
            str += `<span class="pageNum ${'page'+(activePage +1)}" data-page=${activePage +1}>${activePage +1}</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        }
       
    }
    str += `<span class="nextPage"><img class="arrowPage" src=${arrowRight} /></span>`
    $('.pagination').html(str)
    $('.page' + activePage).addClass('activePage')
    $(".pageNum").on("click", function(e){
        const activePageNow = Number($(this).attr('data-page'))
        getTabData(activePageNow)
        // renderPagination(totalPage,activePageNow,totalNum)
    })
    $(".prePage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow > 1){
            activePageNow--
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    $(".nextPage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow < totalPage){
            activePageNow++
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    
}

$(document).on("click", function(){
    $(".levelList ").css("display", "none")
    $(".deptList ").css("display", "none")
    $(".statusList ").css("display", "none")
    $(".selectDept .arrow").attr("src",iconDown)
    $(".selectLevel .arrow").attr("src",iconDown)
    $(".selectStatus .arrow").attr("src",iconDown)
})